#include <bits/stdc++.h>

using namespace std;

int n,k;
int a[500005];
bool b[500005];

int main()
{
    scanf("%d%d",&n,&k);
    for(int i=0; i<n; i++)
        scanf("%d",a+i);
    int mk=0;
    while(k>1)
    {
        int mini=1000000005;
        int minind=mk;
        for(int i=mk; i<mk+k+1; i++)
        {
            if(a[i]<mini)
            {
                mini=a[i];
                minind=i;
            }
        }
        for(int i=mk; i<minind; i++)
        {
            b[i]=true;
            k--;
        }
        //cerr<<mini<<endl;
        mk=minind+1;
    }
    if(k==1)
    {
        for(int i=mk; i<n-1; i++)
        {
            if(a[i]>a[i+1])
            {
                b[i]=true;
                k--;
                break;
            }
        }
        if(k==1)
            b[n-1]=true;
    }
    for(int i=0; i<n; i++)
        if(!b[i])
            printf("%d ",a[i]);
    return 0;
}